## GAsyncResult GAsyncResult — Asynchronous Function Results |

## Functions

void | (*GAsyncReadyCallback) ()
gpointer | g_async_result_get_user_data ()
GObject * | g_async_result_get_source_object ()
gboolean | g_async_result_is_tagged ()
gboolean | g_async_result_legacy_propagate_error ()

## Types and Values

| GAsyncResult
struct | GAsyncResultIface

## Object Hierarchy

        GInterface
        ╰── GAsyncResult

## Prerequisites

GAsyncResult requires GObject.

## Known Implementations

GAsyncResult is implemented by GSimpleAsyncResult and GTask.

## Includes

    #include <gio/gio.h>

## Description

Provides a base class for implementing asynchronous function results.

Asynchronous operations are broken up into two separate operations which are chained together by a GAsyncReadyCallback. To begin an asynchronous operation, provide a GAsyncReadyCallback to the asynchronous function. This callback will be triggered when the operation has completed, and will be passed a GAsyncResult instance filled with the details of the operation's success or failure, the object the asynchronous function was started for and any error codes returned. The asynchronous callback function is then expected to call the corresponding "`_finish()`" function, passing the object the function was called for, the GAsyncResult instance, and (optionally) an `error` to grab any error conditions that may have occurred.

The "`_finish()`" function for an operation takes the generic result (of type GAsyncResult) and returns the specific result that the operation in question yields (e.g. a GFileEnumerator for a "enumerate children" operation). If the result or error status of the operation is not needed, there is no need to call the "`_finish()`" function; GIO will take care of cleaning up the result and error information after the GAsyncReadyCallback returns. You can pass `NULL` for the GAsyncReadyCallback if you don't need to take any action at all after the operation completes. Applications may also take a reference to the GAsyncResult and call "`_finish()`" later; however, the "`_finish()`" function may be called at most once.

Example of a typical asynchronous operation flow:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    void _theoretical_frobnitz_async (Theoretical         *t,
                                      GCancellable        *c,
                                      GAsyncReadyCallback  cb,
                                      gpointer             u);

    gboolean _theoretical_frobnitz_finish (Theoretical   *t,
                                           GAsyncResult  *res,
                                           GError       **e);

    static void
    frobnitz_result_func (GObject      *source_object,
             GAsyncResult *res,
             gpointer      user_data)
    {
      gboolean success = FALSE;

      success = _theoretical_frobnitz_finish (source_object, res, NULL);

      if (success)
        g_printf ("Hurray!\n");
      else
        g_printf ("Uh oh!\n");

      ...

    }

    int main (int argc, void *argv[])
    {
       ...

       _theoretical_frobnitz_async (theoretical_data,
                                    NULL,
                                    frobnitz_result_func,
                                    NULL);

       ...
    }

The callback for an asynchronous operation is called only once, and is always called, even in the case of a cancelled operation. On cancellation the result is a `G_IO_ERROR_CANCELLED` error.

#### I/O Priority

Many I/O-related asynchronous operations have a priority parameter, which is used in certain cases to determine the order in which operations are executed. They are not used to determine system-wide I/O scheduling. Priorities are integers, with lower numbers indicating higher priority. It is recommended to choose priorities between `G_PRIORITY_LOW` and `G_PRIORITY_HIGH`, with `G_PRIORITY_DEFAULT` as a default.

## Functions

### GAsyncReadyCallback ()

    void
    (*GAsyncReadyCallback) (GObject *source_object,
                            GAsyncResult *res,
                            gpointer user_data);

Type definition for a function that will be called back when an asynchronous operation within GIO has been completed.

#### Parameters

source_object | the object the asynchronous operation was started with. |
res | a GAsyncResult. |
user_data | user data passed to the callback. |

### g_async_result_get_user_data ()

    gpointer
    g_async_result_get_user_data (GAsyncResult *res);

Gets the user data from a GAsyncResult.

#### Parameters

res | a GAsyncResult. |

#### Returns

the user data for `res` .

[transfer full]

### g_async_result_get_source_object ()

    GObject *
    g_async_result_get_source_object (GAsyncResult *res);

Gets the source object from a GAsyncResult.

#### Parameters

res | a GAsyncResult |

#### Returns

a new reference to the source object for the `res` , or `NULL` if there is none.

[transfer full]

### g_async_result_is_tagged ()

    gboolean
    g_async_result_is_tagged (GAsyncResult *res,
                              gpointer source_tag);

Checks if `res` has the given `source_tag` (generally a function pointer indicating the function `res` was created by).

#### Parameters

res | a GAsyncResult |
source_tag | an application-defined tag |

#### Returns

`TRUE` if `res` has the indicated `source_tag` , `FALSE` if not.

Since 2.34

### g_async_result_legacy_propagate_error ()

    gboolean
    g_async_result_legacy_propagate_error (GAsyncResult *res,
                                           GError **error);

If `res` is a GSimpleAsyncResult, this is equivalent to `g_simple_async_result_propagate_error()`. Otherwise it returns `FALSE`.

This can be used for legacy error handling in async *_finish() wrapper functions that traditionally handled GSimpleAsyncResult error returns themselves rather than calling into the virtual method. This should not be used in new code; GAsyncResult errors that are set by virtual methods should also be extracted by virtual methods, to enable subclasses to chain up correctly.

#### Parameters

res | a GAsyncResult |
error | a location to propagate the error to. | [out]

#### Returns

`TRUE` if `error` is has been filled in with an error from `res` , `FALSE` if not.

Since 2.34

## Types and Values

### GAsyncResult

    typedef struct _GAsyncResult GAsyncResult;

Holds results information for an asynchronous operation, usually passed directly to a asynchronous `_finish()` operation.

### struct GAsyncResultIface

    struct GAsyncResultIface {
      GTypeInterface g_iface;

      /* Virtual Table */

      gpointer  (* get_user_data)     (GAsyncResult *res);
      GObject * (* get_source_object) (GAsyncResult *res);

      gboolean  (* is_tagged)         (GAsyncResult *res,
    				   gpointer      source_tag);
    };

Interface definition for GAsyncResult.

#### Members

GTypeInterface `g_iface`; | The parent interface. |
`get_user_data` () | Gets the user data passed to the callback. |
`get_source_object` () | Gets the source object that issued the asynchronous operation. |
`is_tagged` () | Checks if a result is tagged with a particular source. |

## See Also

GTask